// Force Trick Panel by Yellow/@GlowingTail
-- Makes the player activate their trick state without the need of a panel, call this with ACS.

local BUILD = 3
if (ForceTrickPanel and ForceTrickPanel.build >= BUILD) return end
local FTP = ForceTrickPanel or {build = BUILD}

local TRICKSTATE_NONE, TRICKSTATE_READY = 0, 1
local ARG_TRICKFAIL, ARG_TRICKMOMENTUM, ARG_COLORMAIN, ARG_COLORSUB = 1, 2, 3, 4

local function getIndicatorColor(color, fallback)
	return pcall(do return skincolors[color] end) and color or (fallback or 1)
end

function FTP.specialExecute(entity, arg)
	if not (entity.mo and entity.mo.valid and entity.mo.player) or (entity.mo.player.spectator) return end
    local pmo = entity.mo
    local p = pmo.player

    if (FixedDiv(pmo.momz * P_MobjFlip(pmo), mapobjectscale) < min(1, arg[ARG_TRICKMOMENTUM] or 10) * FRACUNIT) return end
    if not (p.trickindicator and p.trickindicator.valid) or (p.trickpanel) return end

    p.trickpanel = TRICKSTATE_READY
    p.pflags = $ | PF_TRICKDELAY

	p.trickindicator.scale = 0
    p.trickindicator.color = getIndicatorColor(arg[ARG_COLORMAIN])
	p.trickindicator.tracer.color = getIndicatorColor(arg[ARG_COLORSUB], p.trickindicator.color)
    p.trickpanelfailsafe = arg[ARG_TRICKFAIL] and true or false
end

function FTP.trickIndicatorHook(indicator)
	if not (indicator and indicator.valid and indicator.tracer and indicator.tracer.valid and indicator.target and indicator.target.valid and indicator.target.player and indicator.target.player.valid) return end
	local p = indicator.target.player
	local layered = indicator.tracer

	p.trickindicator = indicator

	if (p.trickpanel == TRICKSTATE_READY) and (indicator.state == S_INVISIBLE or layered.state == S_INVISIBLE)
		indicator.state = S_TRICKINDICATOR_UNDERLAY
		layered.state = S_TRICKINDICATOR_OVERLAY
	end
end

FTP.trickFail = do
	for p in players.iterate do
		if not (p.mo and p.mo.valid and (p.trickpanel == TRICKSTATE_READY) and p.trickpanelfailsafe and not p.spectator) continue end

		if FixedDiv(p.mo.momz * P_MobjFlip(p.mo), mapobjectscale) < -8 * FRACUNIT
			p.trickpanel = TRICKSTATE_NONE
            p.trickpanelfailsafe = false
		end
	end
end

if rawget(_G, 'ForceTrickPanel') ~= nil return end

addHook('SpecialExecute', FTP.specialExecute, 'FORCETRICKPANEL')
addHook('MobjThinker', FTP.trickIndicatorHook, MT_TRICKINDICATOR)
addHook('PreThinkFrame', FTP.trickFail)
rawset(_G, 'ForceTrickPanel', FTP)
print("\132Force Trick Panel\128 has been loaded. \134[Build #"..ForceTrickPanel.build.."]")